function parseCode(code, varnames, varvalues)
{
	for (i = 0; i < varnames.length; i++) // Create available variables
		eval("var " + varnames[i] + " = varvalues[i]");

	eval(code);
}


function SZCodeError (str, e, line) {
	return str.concat("\nSZCode error (line " + line + "): " + e + "\n");
}

function parseSZCode (code, doc, wind, varnames, varvalues) {
	var errorfound = false;

	var parsedCode = "doc.open();\n";
	var bindings = "";

	var tokenizer = /\s+/;
	var tokens;
	var lineseparator = /\n/; // Should split the code up into lines nicely
	var lines = code.split(lineseparator);

	var validVars = new Array();
	for (i = 0; i < varnames.length; i++) { // Create available variables
		eval("var " + varnames[i] + " = varvalues[i]");
		validVars[varnames[i]] = true;
	}

	for (var curline = 0; curline < lines.length; curline++) {
		line = lines[curline];
		if (line[0] == '%' && line[1] != '%') // Break the line with a % to insert JavaScript
			line = line.substring(1,line.length);
		else {
			line = line.replace(/"/g, "\\\""); // Replace all " with \"
			varname = "";
			for (var varloc = line.indexOf("%"); varloc != -1; varloc = line.indexOf("%", varloc+varname.length+8)) {
				if (line.charAt(varloc+1) == "%") {
					line = line.substring(0, varloc+1) + line.substring(varloc+2, line.length); // Only take one of the $ signs
					varloc -= 7; varname = ""; // This is just so that we only skip ahead by 1 when looking for the next variable, it's dirty, but it works
					continue;
				}
				varend = line.indexOf("%", varloc+1); // Find the end of the token
				if (varend == -1) break; // This used to be an error, but I suppose I can allow someone to fudge a little and still have working code
				varname = line.substring(varloc+1, varend);
				//if (validVars[varname])
				line = line.substring(0,varloc) + "\" + " + varname + " + \"" + line.substring(varend+1, line.length); // This used to be done with a regex, but it required too many replaces for special chars
				//else { 
				//	parsedCode = SZCodeError(parsedCode, "Unknown variable: " + varname, curline); continue;
				//}
			}
			line = "doc.writeln(\"" + line + "\");";
			parsedCode = parsedCode.concat(line + "\n");
			continue;
		}
		line = line.substring(line.search(/\S+/), line.length); // Strip opening whitespace
		tokens = line.split(tokenizer);
		if (tokens[0] == "bind") { // Bind a variable to the target window
			var localName;
			var globalName;
			if (tokens[1])
				localName = tokens[1];
			else {
				parsedCode = SZCodeError(parsedCode, "Incorrect use of bind. Correct usage: bind LOCALVARIABLE [GLOBALVARIABLE] ", curline);
				continue;
			}
			if (tokens[2]) globalName = tokens[2];
			else globalName = tokens[1]; // If the global variable is excluded, assume it has the same name as the local
		
			bindings = bindings.concat("wind." + localName + " = " + globalName + ";\n");
			continue;
		}
		else {
			parsedCode = parsedCode.concat(line + "\n");
		}
	}

	parsedCode = parsedCode.concat("doc.close();\n");
	parsedCode = parsedCode.concat(bindings);

	eval(parsedCode);
}

