var PREFLIST = new Array("articlecode", "articlemode", "articleicons", "articleiconwidth",
			"articleheadlineclick", "articlecomments");
var PREFDEFAULTS = new Array();
var PREFTYPES = new Array();

PREFDEFAULTS["articlecode"] = "<html><head></head>\n<body bgcolor=\"#FFFFFF\" link=\"%linkcolor%\">\n<table border=\"0\" width=\"100%\">\n%for (i=0; i < articles.length; i++) {\n  <tr>\n<td valign=\"middle\" align=\"center\">\n<img width=\"30\" height=\"%(articles[i].getImageHeight()*30/articles[i].getImageWidth())%\" src=\"%articles[i].getImage()%\"></td>\n<td valign=\"middle\" width=\"100%\">\n<a style=\"font-size: 12px;\" target=\"_content\" href=\"%articles[i].getLink()%\">%articles[i].getHeadline()%</a>\n<div style=\"font-size: 10px;\">%articles[i].getOfComments()% comments</div>\n</td>\n</tr><tr><td height=\"2\" bgcolor=\"#BBBBBB\" colspan=\"3\"></td></tr>\n%}\n</table></body></html>";
PREFDEFAULTS["articlemode"] = "0";
PREFDEFAULTS["articleicons"] = "0";
PREFDEFAULTS["articleiconwidth"] = "30";
PREFDEFAULTS["articleheadlineclick"] = "0";
PREFDEFAULTS["articlecomments"] = "0";

PREFTYPES["articlecode"] = "text";
PREFTYPES["articlemode"] = "menu";
PREFTYPES["articleicons"] = "menu";
PREFTYPES["articleiconwidth"] = "text";
PREFTYPES["articleheadlineclick"] = "menu";
PREFTYPES["articlecomments"] = "menu";

function readFile(filename) { // I'd like to store default code in separate files eventually, but I have had problems with this so far....
	var req = new XMLHttpRequest();
	req.open("GET", filename, false);
	req.send(null);	
	return req.responseText;
}

var NORMALARTICLECODE = "%bind zoomToHeadline\n<html><head></head>\n<body bgcolor=\"#FFFFFF\" link=\"%linkcolor%\">\n<table border=\"0\" width=\"100%\">\n%for (i=0; i < articles.length; i++) {\n  <tr>\n%if (prefs.getPref(\"articleicons\") == 0) {\n  <td valign=\"middle\" align=\"center\">\n  <img width=\"%prefs.getPref('articleiconwidth')%\" height=\"%(articles[i].getImageHeight()*prefs.getPref('articleiconwidth')/articles[i].getImageWidth())%\" src=\"%articles[i].getImage()%\"></td>\n%}\n  <td valign=\"middle\" width=\"100%\">\n%if (prefs.getPref(\"articleheadlineclick\") == 0) {\n  <a style=\"font-size: 12px;\" target=\"_content\" href=\"%articles[i].getLink()%\">%articles[i].getHeadline()%</a>\n%} else if (prefs.getPref(\"articleheadlineclick\") == 1) {\n  <a style=\"font-size: 12px;\" href=\"javascript:zoomToHeadline(%i%);\">%articles[i].getHeadline()%</a>\n%} else if (prefs.getPref(\"articleheadlineclick\") == 2) {\n  <div style=\"font-size: 12px;\">%articles[i].getHeadline()%</div>\n%}\n%if (prefs.getPref(\"articlecomments\") == 0) {\n  <div style=\"font-size: 10px;\">%articles[i].getOfComments()% comments</div>\n%} else if (prefs.getPref(\"articlecomments\") == 1) {\n  </td><td valign=\"middle\" align=\"center\" nowrap><div style=\"font-size: 10px;\">%articles[i].getOfComments()%<br>comments</div>\n%}\n  </td>\n%if (prefs.getPref(\"articleicons\") == 1) {\n  <td valign=\"middle\" align=\"center\">\n  <img width=\"%prefs.getPref('articleiconwidth')%\" height=\"%(articles[i].getImageHeight()*prefs.getPref('articleiconwidth')/articles[i].getImageWidth())%\" src=\"%articles[i].getImage()%\"></td>\n%}\n</tr><tr><td height=\"2\" bgcolor=\"#BBBBBB\" colspan=\"3\"></td></tr>\n%}\n</table></body></html>";

function PrefsManager ()
{
	this.prefs = new Array();
	this.loadPrefs();
}

PrefsManager.prototype.getPref = 
function (name) {
	if (this.prefs[name])
		return this.prefs[name];
	return null;
}

PrefsManager.prototype.loadPrefs = 
function () {
	try {
		var prefservice = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
		prefservice = prefservice.getBranch("slashzilla.");
		for (var i = 0; i < PREFLIST.length; i++)
			this.prefs[PREFLIST[i]] = prefservice.getCharPref(PREFLIST[i]);
	} catch(exception) {}
	for (var i = 0; i < PREFLIST.length; i++) {
		if (!this.prefs[PREFLIST[i]])
			this.prefs[PREFLIST[i]] = PREFDEFAULTS[PREFLIST[i]];
	}
}

PrefsManager.prototype.displayPrefs =
function () {
	for (var i = 0; i < PREFLIST.length; i++) {
		if (PREFTYPES[PREFLIST[i]] == "text")
			document.getElementById(PREFLIST[i]).value = this.prefs[PREFLIST[i]];
		else if (PREFTYPES[PREFLIST[i]] == "menu")
			document.getElementById(PREFLIST[i]).selectedIndex = this.prefs[PREFLIST[i]];
	}
}

PrefsManager.prototype.readPrefs =
function () {
	for (var i = 0; i < PREFLIST.length; i++) {
		if (PREFTYPES[PREFLIST[i]] == "text")
			this.prefs[PREFLIST[i]] = document.getElementById(PREFLIST[i]).value;
		else if (PREFTYPES[PREFLIST[i]] == "menu")
			this.prefs[PREFLIST[i]] = "" + document.getElementById(PREFLIST[i]).selectedIndex;
	}
}

PrefsManager.prototype.savePrefs = 
function () {
	var prefservice = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
	prefservice = prefservice.getBranch("slashzilla.");

	for (var i = 0; i < PREFLIST.length; i++)
		prefservice.setCharPref(PREFLIST[i], this.prefs[PREFLIST[i]]);
}

function restoreDefault(name) {
	if (PREFTYPES[name] == "text")
		document.getElementById(name).value = PREFDEFAULTS[name];
	else if (PREFTYPES[name] == "menu")
		document.getElementById(name).selectedIndex = PREFDEFAULTS[name];
}

function renderArticlePreview() {
	prefs.readPrefs();
	var articles = new Array();
	articles[articles.length] = new SlashdotArticle(null, "Slashzilla Shows Everyone Slashdot Articles!", "javascript:;", "5", "10", "chrome://slashzilla/content/logo.png", "30", "30", "Entrager", "1981-09-15 14:22:22", "getting-info-faster");
	articles[articles.length] = new SlashdotArticle(null, "Man Lands on the Moon!", "javascript:;", "44", "8149", "chrome://slashzilla/content/logo.png", "30", "30", "Entrager", "1981-09-15 14:22:22", "who-knew?");
	oIFrame = document.getElementById("articlepreview");
	var varnames = new Array("linkcolor", "articles", "zoomToHeadline");
	var varvalues = new Array("#006666", articles, null);
	if (prefs.getPref("articlemode") == 0)
		parseSZCode(NORMALARTICLECODE, oIFrame.contentDocument, oIFrame.contentWindow, varnames, varvalues);
	else
		parseSZCode(document.getElementById("articlecode").value, oIFrame.contentDocument, oIFrame.contentWindow, varnames, varvalues);
}

function changePrefPage() {
	var deck = document.getElementById("articledeck");
	var selector = document.getElementById("articlemode");

	if (selector.selectedIndex == 0)
		deck.selectedIndex = 0;
	else
		deck.selectedIndex = 1;
}

prefs = new PrefsManager();